"use strict";
exports.__esModule = true;
var Retry_1 = require("./Retry");
/**
 * Http class
 */
var RetryMap = /** @class */ (function () {
    function RetryMap() {
        this.retries = {};
    }
    /**
     * Add retry
     *
     * @param retry
     */
    RetryMap.prototype.addRetry = function (retry) {
        this.retries[retry.getUrl() + "~~" + retry.getMethod()] = retry;
    };
    /**
     * Create from array
     */
    RetryMap.createFromArray = function (array) {
        var retryMap = new RetryMap();
        retryMap.retries = array.map(function (retry) { return Retry_1.Retry.createFromArray(retry); });
        return retryMap;
    };
    /**
     * Get retry
     *
     * @param url
     * @param method
     *
     * @returns {Retry}
     */
    RetryMap.prototype.getRetry = function (url, method) {
        if (this.retries[url + "~~" + method] instanceof Retry_1.Retry) {
            return this.retries[url + "~~" + method];
        }
        if (this.retries["*~~" + method] instanceof Retry_1.Retry) {
            return this.retries["*~~" + method];
        }
        if (this.retries[url + "~~*"] instanceof Retry_1.Retry) {
            return this.retries[url + "~~*"];
        }
        if (this.retries["*~~*"] instanceof Retry_1.Retry) {
            return this.retries["*~~*"];
        }
        return null;
    };
    return RetryMap;
}());
exports.RetryMap = RetryMap;
